/*
 Nome: BACKUP_CMPSUP
 Criao: 27/04/2010 - Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE
PROCEDURE ROTINA_BACKUP(
   P_NRSEQESPELHOTAB VARCHAR2,
   P_SISTEMA         VARCHAR2)
IS
   V_NMLINKREPLDEST  PARAMESPELHOTAB.NMLINKREPLDEST%TYPE;
   V_DTINIESPELHOTAB ESPELHOTABSIST.DTINIESPELHOTAB%TYPE;
   V_DTFINESPELHOTAB ESPELHOTABSIST.DTFINESPELHOTAB%TYPE;
   V_IDLIMPARTABDEST ESPELHOTABSIST.IDLIMPARTABDEST%TYPE;
   V_IDESTESPELHOTAB ESPELHOTABSIST.IDESTESPELHOTAB%TYPE;
   V_IDSITESPELHOTAB PARAMESPELHOTAB.IDSITESPELHOTAB%TYPE;
   V_NRSQLESPELHOTAB PARAMSQLESPTAB.NRSQLESPELHOTAB%TYPE;
   V_IDCONSCADESPTAB PARAMESPELHOTAB.IDCONSCADESPTAB%TYPE;
   V_IDVERCONSESPTAB PARAMESPELHOTAB.IDVERCONSESPTAB%TYPE;
   V_CURSOR_TABELA   VARCHAR2(30);

   V_SQLOBJETO          VARCHAR2(6000);
   V_NRSQLPROXIMOCODIGO VARCHAR2(20);
   V_CONSTRAINT_NAME USER_CONSTRAINTS.CONSTRAINT_NAME%TYPE;
   V_TABLE_NAME      USER_CONSTRAINTS.TABLE_NAME%TYPE;
   V_TRIGGER_NAME    USER_TRIGGERS.TRIGGER_NAME%TYPE;

   TYPE CURTYPE      IS REF CURSOR;
   CUR_CONSTRAINTS   CURTYPE;
   CUR_TRIGGERS      CURTYPE;

   V_COUNT           FLOAT;

   CURSOR C_TABELAS_GERAL IS
   (SELECT USER_TABLES.TABLE_NAME
    FROM USER_TABLES
    WHERE NOT EXISTS (SELECT 1
                      FROM TAB_AREANEGOCIO
                      WHERE TAB_AREANEGOCIO.NMTABELANEGOCIO = USER_TABLES.TABLE_NAME))
    ORDER BY USER_TABLES.TABLE_NAME;

   CURSOR C_TABELAS_AREANEGOCIO IS
   (SELECT NMTABELANEGOCIO
    FROM TAB_AREANEGOCIO
    WHERE CDAREANEGOCIO = P_SISTEMA)
    ORDER BY NMTABELANEGOCIO;
BEGIN
   UPDATE PARAMESPELHOTAB
   SET IDSITESPELHOTAB = 'A'
   WHERE NRSEQESPELHOTAB = P_NRSEQESPELHOTAB;

   SELECT
      MAX(ESPELHOTABSIST.DTINIESPELHOTAB),
      MAX(ESPELHOTABSIST.DTFINESPELHOTAB),
      MAX(ESPELHOTABSIST.IDLIMPARTABDEST),
      MAX(ESPELHOTABSIST.IDESTESPELHOTAB),
      MAX(PARAMESPELHOTAB.IDSITESPELHOTAB),
      MAX(PARAMESPELHOTAB.NMLINKREPLDEST),
      MAX(PARAMESPELHOTAB.IDCONSCADESPTAB),
      MAX(PARAMESPELHOTAB.IDVERCONSESPTAB)
   INTO
      V_DTINIESPELHOTAB,
      V_DTFINESPELHOTAB,
      V_IDLIMPARTABDEST,
      V_IDESTESPELHOTAB,
      V_IDSITESPELHOTAB,
      V_NMLINKREPLDEST,
      V_IDCONSCADESPTAB,
      V_IDVERCONSESPTAB
   FROM PARAMESPELHOTAB, ESPELHOTABSIST
   WHERE PARAMESPELHOTAB.NRSEQESPELHOTAB = ESPELHOTABSIST.NRSEQESPELHOTAB
     AND PARAMESPELHOTAB.NRSEQESPELHOTAB = P_NRSEQESPELHOTAB
     AND ESPELHOTABSIST.IDSISESPELHOTAB = P_SISTEMA;

   /*Desabilita Constraints*/
   IF V_IDVERCONSESPTAB = 'N' THEN
      UPDATE PARAMESPELHOTAB
      SET IDVERCONSESPTAB = 'S'
      WHERE NRSEQESPELHOTAB = P_NRSEQESPELHOTAB;
      COMMIT;

      V_SQLOBJETO := 'SELECT DEST.CONSTRAINT_NAME, DEST.TABLE_NAME '||
                     'FROM USER_CONSTRAINTS@'||V_NMLINKREPLDEST||' DEST '||
                     'WHERE DEST.STATUS = '''||'ENABLED'||''' ' ||
                     '  AND DEST.CONSTRAINT_TYPE = '''||'R'||''' '||
                     'ORDER BY DEST.CONSTRAINT_NAME';
      OPEN CUR_CONSTRAINTS FOR V_SQLOBJETO;
      LOOP
         FETCH CUR_CONSTRAINTS INTO V_CONSTRAINT_NAME, V_TABLE_NAME;
         EXIT WHEN CUR_CONSTRAINTS%NOTFOUND;

         NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
         V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
         V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);

         INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
         VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'DDL');

         INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
         VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                'ALTER TABLE ' ||   V_TABLE_NAME || ' DISABLE CONSTRAINT ' || V_CONSTRAINT_NAME);
         COMMIT;
      END LOOP;
      CLOSE CUR_CONSTRAINTS;

      V_SQLOBJETO := 'SELECT DEST.CONSTRAINT_NAME, DEST.TABLE_NAME '||
                     'FROM USER_CONSTRAINTS@'||V_NMLINKREPLDEST||' DEST '||
                     'WHERE DEST.STATUS = '''||'ENABLED'||''' ' ||
                     '  AND DEST.CONSTRAINT_TYPE <> '''||'C'||''' '||
                     '  AND DEST.CONSTRAINT_TYPE <> '''||'R'||''' '||
                     'ORDER BY DEST.CONSTRAINT_NAME';
      OPEN CUR_CONSTRAINTS FOR V_SQLOBJETO;
      LOOP
         FETCH CUR_CONSTRAINTS INTO V_CONSTRAINT_NAME, V_TABLE_NAME;
         EXIT WHEN CUR_CONSTRAINTS%NOTFOUND;

         NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
         V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
         V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);

         INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
         VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'DDL');

         INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
         VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                'ALTER TABLE ' || V_TABLE_NAME || ' DISABLE CONSTRAINT ' || V_CONSTRAINT_NAME);
         COMMIT;
      END LOOP;
      CLOSE CUR_CONSTRAINTS;

      V_SQLOBJETO := 'SELECT DEST.TRIGGER_NAME '||
                     'FROM USER_TRIGGERS@'||V_NMLINKREPLDEST||' DEST '||
                     'WHERE DEST.STATUS = '''||'ENABLED'||''' ' ||
                     'ORDER BY DEST.TRIGGER_NAME';
      OPEN CUR_TRIGGERS FOR V_SQLOBJETO;
      LOOP
         FETCH CUR_TRIGGERS INTO V_TRIGGER_NAME;
         EXIT WHEN CUR_TRIGGERS%NOTFOUND;

         NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
         V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
         V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);

         INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
         VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'DDL');

         INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
         VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                'ALTER TRIGGER ' ||   V_TRIGGER_NAME || ' DISABLE');

         COMMIT;
      END LOOP;
      CLOSE CUR_TRIGGERS;
   END IF;

   UPDATE ESPELHOTABSIST
      SET IDSTATUSESPSIST = 'A'
    WHERE NRSEQESPELHOTAB = P_NRSEQESPELHOTAB
      AND IDSISESPELHOTAB = P_SISTEMA;
   COMMIT;

   OPEN C_TABELAS_AREANEGOCIO;
   LOOP
      FETCH C_TABELAS_AREANEGOCIO INTO V_CURSOR_TABELA;
      EXIT WHEN C_TABELAS_AREANEGOCIO%NOTFOUND;
      OPERACAO_TABELA_BACKUP(P_NRSEQESPELHOTAB, V_CURSOR_TABELA, V_NMLINKREPLDEST, V_IDLIMPARTABDEST, 'N', V_DTINIESPELHOTAB, V_DTFINESPELHOTAB, 'N');
      IF V_IDESTESPELHOTAB = 'N' THEN
         OPERACAO_TABELA_BACKUP(P_NRSEQESPELHOTAB, V_CURSOR_TABELA, V_NMLINKREPLDEST, V_IDLIMPARTABDEST, 'S', V_DTINIESPELHOTAB, V_DTFINESPELHOTAB, 'N');
      END IF;
      COMMIT;
   END LOOP;
   CLOSE C_TABELAS_AREANEGOCIO;

   UPDATE ESPELHOTABSIST
      SET IDSTATUSESPSIST = 'C'
    WHERE NRSEQESPELHOTAB = P_NRSEQESPELHOTAB
      AND IDSISESPELHOTAB = P_SISTEMA;
   COMMIT;

   V_COUNT := 0;
   SELECT COUNT(1)
     INTO V_COUNT
     FROM ESPELHOTABSIST
    WHERE NRSEQESPELHOTAB = P_NRSEQESPELHOTAB
      AND IDSTATUSESPSIST = 'P';

   IF NOT(V_COUNT > 0) THEN
      IF V_IDCONSCADESPTAB = 'N' THEN
         UPDATE PARAMESPELHOTAB
         SET IDCONSCADESPTAB = 'S'
         WHERE NRSEQESPELHOTAB = P_NRSEQESPELHOTAB;
         COMMIT;
         OPEN C_TABELAS_GERAL;
         LOOP
            FETCH C_TABELAS_GERAL INTO V_CURSOR_TABELA;
            EXIT WHEN C_TABELAS_GERAL%NOTFOUND;
            OPERACAO_TABELA_BACKUP(P_NRSEQESPELHOTAB, V_CURSOR_TABELA, V_NMLINKREPLDEST, V_IDLIMPARTABDEST, 'N', V_DTINIESPELHOTAB, V_DTFINESPELHOTAB, 'S');
            IF V_IDESTESPELHOTAB = 'N' THEN
               OPERACAO_TABELA_BACKUP(P_NRSEQESPELHOTAB, V_CURSOR_TABELA, V_NMLINKREPLDEST, V_IDLIMPARTABDEST, 'S', V_DTINIESPELHOTAB, V_DTFINESPELHOTAB, 'S');
            END IF;
            COMMIT;
         END LOOP;

         V_SQLOBJETO := 'SELECT DEST.CONSTRAINT_NAME, DEST.TABLE_NAME '||
                        'FROM USER_CONSTRAINTS@'||V_NMLINKREPLDEST||' DEST '||
                        'WHERE DEST.STATUS = '''||'DISABLED'||''' ' ||
                        '  AND DEST.CONSTRAINT_TYPE <> '''||'C'||''' '||
                        '  AND DEST.CONSTRAINT_TYPE <> '''||'R'||''' '||
                        'ORDER BY DEST.CONSTRAINT_NAME';
         OPEN CUR_CONSTRAINTS FOR V_SQLOBJETO;
         LOOP
            FETCH CUR_CONSTRAINTS INTO V_CONSTRAINT_NAME, V_TABLE_NAME;
            EXIT WHEN CUR_CONSTRAINTS%NOTFOUND;

            NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
            V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
            V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);

            INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
            VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'OBJ');

            INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
            VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                   'ALTER TABLE ' || V_TABLE_NAME || ' ENABLE CONSTRAINT ' || V_CONSTRAINT_NAME);

            COMMIT;
         END LOOP;
         CLOSE CUR_CONSTRAINTS;

         V_SQLOBJETO := 'SELECT DEST.CONSTRAINT_NAME, DEST.TABLE_NAME '||
                        'FROM USER_CONSTRAINTS@'||V_NMLINKREPLDEST||' DEST '||
                        'WHERE DEST.STATUS = '''||'DISABLED'||''' ' ||
                        '  AND DEST.CONSTRAINT_TYPE = '''||'R'||''' '||
                        'ORDER BY DEST.CONSTRAINT_NAME';
         OPEN CUR_CONSTRAINTS FOR V_SQLOBJETO;
         LOOP
            FETCH CUR_CONSTRAINTS INTO V_CONSTRAINT_NAME, V_TABLE_NAME;
            EXIT WHEN CUR_CONSTRAINTS%NOTFOUND;

            NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
            V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
            V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);

            INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
            VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'REF');

            INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
            VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                   'ALTER TABLE ' ||   V_TABLE_NAME || ' ENABLE CONSTRAINT ' || V_CONSTRAINT_NAME);

            COMMIT;
         END LOOP;
         CLOSE CUR_CONSTRAINTS;

         V_SQLOBJETO := 'SELECT DEST.TRIGGER_NAME '||
                        'FROM USER_TRIGGERS@'||V_NMLINKREPLDEST||' DEST '||
                        'WHERE DEST.STATUS = '''||'DISABLED'||''' ' ||
                        'ORDER BY DEST.TRIGGER_NAME';
         OPEN CUR_TRIGGERS FOR V_SQLOBJETO;
         LOOP
            FETCH CUR_TRIGGERS INTO V_TRIGGER_NAME;
            EXIT WHEN CUR_TRIGGERS%NOTFOUND;

            NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
            V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
            V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);

            INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
            VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'REF');

            INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
            VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                   'ALTER TRIGGER ' ||   V_TRIGGER_NAME || ' ENABLE');
            COMMIT;
         END LOOP;
         CLOSE CUR_TRIGGERS;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ROTINA_BACKUP','5.09.000'); END;
/


