IF EXISTS ( SELECT *
              FROM SYSOBJECTS O, SYSUSERS U                            
             WHERE O.NAME = 'CTB_BCO_LANC'
               AND TYPE  = 'P'
               AND U.UID = O.UID
               AND U.NAME = USER )

DROP PROCEDURE CTB_BCO_LANC
GO
CREATE PROCEDURE CTB_BCO_LANC              
@P_NRLANCCTBTEMP VARCHAR(12),
@P_CDREDUCONT VARCHAR(3),
@P_NRMOVI VARCHAR(10),
@P_IDTIPO VARCHAR,
@P_NRLANCCTB VARCHAR(12) OUTPUT

AS
   DECLARE @V_NRLANCTEMP VARCHAR(20);
   DECLARE @V_CDEMPRESA VARCHAR(2);
   DECLARE @V_DSHISTLANC VARCHAR(200);
   DECLARE @V_ERRO DOUBLE PRECISION;
   DECLARE @V_CDCONTCOME VARCHAR(21);
   DECLARE @V_IDTIPOCOME VARCHAR;
   DECLARE @V_IDCONTCCUS VARCHAR;
   DECLARE @V_CDCENTCUST VARCHAR(4);
   DECLARE @V_CDFILIAL VARCHAR(4);
   DECLARE @V_COUNT DOUBLE PRECISION;
   DECLARE @V_VRRATEIO NUMERIC(13,2);
   DECLARE @V_DTLANCTBTEMP DATETIME;
   DECLARE @V_CREDDEB VARCHAR;
   DECLARE @V_RATSEQ DOUBLE PRECISION;
   DECLARE @V_CONTRAT VARCHAR(01);
   DECLARE @V_CONTCOME VARCHAR(01);
   DECLARE @V_SEQUENCIAL VARCHAR(05);
   DECLARE @V_STDATA VARCHAR(200);


   /* VARIVIES DO CURSOR @C_MOVI */
   DECLARE @C_MOVI_CDREDUCONT VARCHAR(3);
   DECLARE @C_MOVI_NRMOVICRED VARCHAR(10);
   DECLARE @C_MOVI_CDHISTPADR VARCHAR(4);
   DECLARE @C_MOVI_CONTA_DEB VARCHAR(20);
   DECLARE @C_MOVI_DTMOVICRED DATETIME;
   DECLARE @C_MOVI_VRMOVICRED NUMERIC(13,2);
   DECLARE @C_MOVI_CDCLIENTE VARCHAR(21);
   DECLARE @C_MOVI_CDFORNECED VARCHAR(21);
   DECLARE @C_MOVI_CDFILIAL VARCHAR(4);
   DECLARE @C_MOVI_CONTA_CRE VARCHAR(20);
   DECLARE @C_MOVI_CDTPCREDBANC VARCHAR(4);
   DECLARE @C_MOVI_NRDOCMBANC VARCHAR(10);
   DECLARE @C_MOVI_NRMOVIDEBI VARCHAR(10);
   DECLARE @C_MOVI_DTMOVIDEBI DATETIME;
   DECLARE @C_MOVI_VRMOVIDEBI NUMERIC (13,2);
   DECLARE @C_MOVI_CDTPDEBIBANC VARCHAR(4);


   /* VARIVEIS DO CURSOR @C_RAT */
   DECLARE @C_RAT_CDCENTCUST VARCHAR(4);
   DECLARE @C_RAT_CDFILIAL VARCHAR(4);
   DECLARE @C_RAT_VRPERATTPCRE NUMERIC (13,2);
   DECLARE @C_RAT_VRPERATTPDEB NUMERIC (13,2);

BEGIN
   SET @V_ERRO = 0;

   SELECT @V_CDEMPRESA = CDEMPRESA
     FROM CONTCORR
    WHERE CDREDUCONT = @P_CDREDUCONT;

   SELECT @V_CONTRAT = IDCONTGERE
     FROM CONTOPECTBL
    WHERE CDEMPRESA = @V_CDEMPRESA;

    IF @P_NRLANCCTBTEMP IS NOT NULL  BEGIN
    /* DELETE RESPONSVEL POR DELETAR OS LANAMENTOS NA LANCCONT COM O MESMO SEQUENCIAL DO LANAMENTO NO BCO, POSTERIORMENTE IR RECONTABILIZAR O MESMO */
       DELETE
         FROM LANCCCUSTO
        WHERE NRLANCCONT = @P_NRLANCCTBTEMP
          AND CDEMPRESA  = @V_CDEMPRESA;
       DELETE
         FROM LANCCONT
        WHERE NRLANCCONT = @P_NRLANCCTBTEMP
          AND CDEMPRESA  = @V_CDEMPRESA;
    END;


    SET @V_NRLANCTEMP = @P_NRLANCCTBTEMP;

   IF @P_IDTIPO = 'C' BEGIN
      /* PEGA A DATA DE MOVIMENTAO,  A DATA INFORMADA NA TELA BCO11100 */
      SELECT @V_DTLANCTBTEMP = DTMOVICRED
        FROM MOVCREDBANC
       WHERE CDREDUCONT = @P_CDREDUCONT
         AND NRMOVICRED = @P_NRMOVI;

      SELECT @V_COUNT = COUNT(*)
        FROM PARAMCTBL
       WHERE @V_DTLANCTBTEMP >= DTINTCTBBCO;

      IF @V_COUNT > 0 BEGIN
         IF @V_NRLANCTEMP IS NULL BEGIN
            SET @V_STDATA = 'LANCCONTABIL'+@V_CDEMPRESA+CONVERT(VARCHAR,YEAR(@V_DTLANCTBTEMP))+ CONVERT(VARCHAR,MONTH(@V_DTLANCTBTEMP));
            EXEC NOVO_CODIGO @V_STDATA,@V_NRLANCTEMP OUTPUT,1
            SET @V_NRLANCTEMP = CONVERT(VARCHAR,YEAR(@V_DTLANCTBTEMP))+ CONVERT(VARCHAR,MONTH(@V_DTLANCTBTEMP))+ SUBSTRING(@V_NRLANCTEMP, 15, 6);

         END;

         /* DELETA TODOS OS REGISTROS TEMPORRIOS PARA ESSE LANAMENTO */
         DELETE FROM LANCCTBTEMP
          WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
            AND CDEMPRESA     = @V_CDEMPRESA;

         DELETE FROM RATECTBTEMP
          WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
            AND CDEMPRESA     = @V_CDEMPRESA;

         DECLARE C_MOVI CURSOR FOR
            (SELECT M.CDREDUCONT, M.NRMOVICRED, T.CDHISTPADR, C.CDCONTCTBL CONTA_DEB, DTMOVICRED,
                   M.VRMOVICRED, M.CDCLIENTE, M.CDFORNECED, M.CDFILIAL, T.CDCONTCTBL CONTA_CRE,
                   M.CDTPCREDBANC, B.NRDOCMBANC
              FROM MOVCREDBANC M, TPCREDBANC T, CONTCORR C, MOVBANCARIO B
             WHERE M.CDTPCREDBANC = T.CDTPCREDBANC
               AND M.CDREDUCONT   = C.CDREDUCONT
               AND M.NRMOVBANC    = B.NRMOVBANC
               AND M.CDREDUCONT   = B.CDREDUCONT
               AND M.CDREDUCONT = @P_CDREDUCONT
               AND M.NRMOVICRED = @P_NRMOVI);
            OPEN C_MOVI;
            FETCH NEXT FROM C_MOVI INTO @C_MOVI_CDREDUCONT, @C_MOVI_NRMOVICRED, @C_MOVI_CDHISTPADR, @C_MOVI_CONTA_DEB,
               @C_MOVI_DTMOVICRED, @C_MOVI_VRMOVICRED, @C_MOVI_CDCLIENTE, @C_MOVI_CDFORNECED, @C_MOVI_CDFILIAL, @C_MOVI_CONTA_CRE,
               @C_MOVI_CDTPCREDBANC, @C_MOVI_NRDOCMBANC;

            WHILE (@@FETCH_STATUS = 0) BEGIN
              -- Formata a Descrio do Histrico
               EXEC CTB_HIST_BCO @C_MOVI_CDREDUCONT, @C_MOVI_NRMOVICRED, @C_MOVI_CDHISTPADR, '','C', @P_STDSHISTPADR = @V_DSHISTLANC OUTPUT;


               /*************************************************************************************
                                  PARTIDA DE DBITO
                ************************************************************************************/

               -- Verifica se a conta contbil  do tipo comercial (banco, fornecedor ou cliente)

                SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME , 'N'),  @V_IDCONTCCUS = IDCONTCCUS
                  FROM CONTCTBL
                 WHERE CDCONTCTBL = @C_MOVI_CONTA_DEB;

                IF @V_IDTIPOCOME = 'B' BEGIN
                   SET @V_CDCONTCOME = @C_MOVI_CDREDUCONT;
                END

                ELSE IF @V_IDTIPOCOME = 'C' BEGIN
                   SET @V_CDCONTCOME = @C_MOVI_CDCLIENTE;
                END

                ELSE IF @V_IDTIPOCOME = 'F' BEGIN
                   SET @V_CDCONTCOME = @C_MOVI_CDFORNECED;
                END

                ELSE BEGIN
                   SET @V_CDCONTCOME = NULL;
                END;

                SET @V_COUNT = 0;
                SELECT @V_COUNT = COUNT(*)
                  FROM LANCCTBTEMP
                 WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                   AND CDEMPRESA     = @V_CDEMPRESA
                   AND CDCONTCTBL    = @C_MOVI_CONTA_DEB;

                IF @V_COUNT = 0 BEGIN

                   INSERT INTO LANCCTBTEMP
                     (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                      DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                   VALUES
                     (@V_CDEMPRESA, @V_NRLANCTEMP, @C_MOVI_NRDOCMBANC, '00001', @C_MOVI_CONTA_DEB, @C_MOVI_CDHISTPADR,
                      @V_DSHISTLANC, @C_MOVI_DTMOVICRED, @C_MOVI_VRMOVICRED * -1, @V_IDTIPOCOME, @V_CDCONTCOME, 'BCO');

                END
                ELSE BEGIN
                   UPDATE LANCCTBTEMP
                      SET VRLANCCTBTEMP = VRLANCCTBTEMP + (@C_MOVI_VRMOVICRED * -1)
                    WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                      AND CDEMPRESA     = @V_CDEMPRESA
                      AND CDCONTCTBL    = @C_MOVI_CONTA_DEB;

                END;



                 -- Realiza o rateio caso a conta contbil no seja "S Oficial"
                 IF @V_CONTRAT= 'S' BEGIN
                    IF @V_IDCONTCCUS <> 'O' BEGIN

                       --Traz o Centro de Custo da Filial, caso seja nulo traz o da Empresa
                       SELECT @V_CDCENTCUST = CDCENTCUST
                         FROM FILIAL
                        WHERE CDFILIAL = @C_MOVI_CDFILIAL;

                        IF @V_CDCENTCUST IS NULL BEGIN
                           SELECT @V_CDCENTCUST = CDCENTCUST
                             FROM EMPRESA
                             WHERE CDEMPRESA = @V_CDEMPRESA;
                        END;

                       SET @V_COUNT = 0;
                       SELECT @V_COUNT = COUNT(*)
                         FROM RATECTBTEMP
                        WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                          AND CDEMPRESA     = @V_CDEMPRESA
                          AND CDFILIAL      = @C_MOVI_CDFILIAL
                          AND CDCENTCUST    = @V_CDCENTCUST
                          AND NRSEQCTBTEMP  = '00001';

                       IF @V_COUNT = 0 BEGIN
                          INSERT INTO RATECTBTEMP
                             (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                          VALUES
                             (@V_CDEMPRESA, @V_NRLANCTEMP, '00001',@C_MOVI_CDFILIAL, @V_CDCENTCUST, @C_MOVI_VRMOVICRED * -1, @C_MOVI_DTMOVICRED, '00001');

                       END
                       ELSE BEGIN
                          UPDATE RATECTBTEMP
                             SET VRRATECTBTEMP = VRRATECTBTEMP + (@C_MOVI_VRMOVICRED * -1)
                           WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                             AND CDEMPRESA     = @V_CDEMPRESA
                             AND CDFILIAL      = @C_MOVI_CDFILIAL
                             AND CDCENTCUST    = @V_CDCENTCUST
                             AND NRSEQCTBTEMP  = '00001';
                       END;
                    END;
                 END;


                /*************************************************************************************
                                  PARTIDA DE CRDITO
                ************************************************************************************/
                SET @V_IDTIPOCOME = NULL;
                SET @V_IDCONTCCUS = NULL;
                SET @V_VRRATEIO   = 0;
                SET @V_COUNT      = 0;

                 -- Verifica se a conta contbil  do tipo comercial (banco, fornecedor ou cliente)
                SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME, 'N'),  @V_IDCONTCCUS = IDCONTCCUS
                  FROM CONTCTBL
                 WHERE CDCONTCTBL = @C_MOVI_CONTA_CRE;

                IF @V_IDTIPOCOME = 'B' BEGIN
                   SET @V_CDCONTCOME = @C_MOVI_CDREDUCONT;
                END

                ELSE IF @V_IDTIPOCOME = 'C' BEGIN
                   SET @V_CDCONTCOME = @C_MOVI_CDCLIENTE;
                END

                ELSE IF @V_IDTIPOCOME = 'F' BEGIN
                   SET @V_CDCONTCOME = @C_MOVI_CDFORNECED;
                END

                ELSE BEGIN
                   SET @V_CDCONTCOME = NULL;
                END;

                SELECT @V_COUNT = COUNT(*)
                  FROM LANCCTBTEMP
                 WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                   AND CDEMPRESA     = @V_CDEMPRESA
                   AND CDCONTCTBL    = @C_MOVI_CONTA_CRE;

                IF @V_COUNT = 0 BEGIN
                   INSERT INTO LANCCTBTEMP
                      (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                       DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                   VALUES
                      (@V_CDEMPRESA, @V_NRLANCTEMP, @C_MOVI_NRDOCMBANC, '00002', @C_MOVI_CONTA_CRE, @C_MOVI_CDHISTPADR,
                       @V_DSHISTLANC, @C_MOVI_DTMOVICRED, @C_MOVI_VRMOVICRED, @V_IDTIPOCOME, @V_CDCONTCOME, 'BCO');

                END
                ELSE BEGIN
                   UPDATE LANCCTBTEMP
                      SET VRLANCCTBTEMP = VRLANCCTBTEMP + @C_MOVI_VRMOVICRED
                    WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                      AND CDEMPRESA     = @V_CDEMPRESA
                      AND CDCONTCTBL    = @C_MOVI_CONTA_CRE;
                END;


                IF @V_CONTRAT = 'S' BEGIN
                   IF @V_IDCONTCCUS <> 'O' BEGIN
                      SELECT @V_COUNT = COUNT (*)
                        FROM RATTPCRED
                       WHERE CDTPCREDBANC = @C_MOVI_CDTPCREDBANC;

                      IF @V_COUNT > 0 BEGIN
                         SET @V_RATSEQ = 1;
                         DECLARE C_RAT CURSOR FOR
                            (SELECT CDCENTCUST, CDFILIAL, VRPERATTPCRE
                              FROM RATTPCRED
                             WHERE CDTPCREDBANC = @C_MOVI_CDTPCREDBANC);
                            OPEN C_RAT;
                            FETCH NEXT FROM C_RAT INTO @C_RAT_CDCENTCUST, @C_RAT_CDFILIAL, @C_RAT_VRPERATTPCRE;
                            WHILE (@@FETCH_STATUS = 0) BEGIN

                               SET @V_COUNT = 0;
                               SELECT @V_COUNT = COUNT(*)
                                 FROM RATECTBTEMP
                                WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                                  AND CDEMPRESA     = @V_CDEMPRESA
                                  AND NRSEQCTBTEMP  = '00002'
                                  AND CDFILIAL      = ISNULL(@C_RAT_CDFILIAL, @C_MOVI_CDFILIAL)
                                  AND CDCENTCUST    = @C_RAT_CDCENTCUST;

                               IF @V_COUNT = 0 BEGIN
                                  INSERT INTO RATECTBTEMP
                                     (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                                  VALUES
                                     (@V_CDEMPRESA, @V_NRLANCTEMP,'00002',ISNULL(@C_RAT_CDFILIAL, @C_MOVI_CDFILIAL),@C_RAT_CDCENTCUST,
                                      ROUND ((@C_MOVI_VRMOVICRED * @C_RAT_VRPERATTPCRE)/100,2),@C_MOVI_DTMOVICRED, RIGHT(REPLICATE('0',5)+ CONVERT(VARCHAR(5), @V_RATSEQ),5));


                               END
                               ELSE BEGIN
                                  UPDATE RATECTBTEMP
                                     SET VRRATECTBTEMP = VRRATECTBTEMP +  ROUND((@C_MOVI_VRMOVICRED * @C_RAT_VRPERATTPCRE)/100, 2)
                                   WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                                     AND CDEMPRESA     = @V_CDEMPRESA
                                     AND NRSEQCTBTEMP  = '00002'
                                     AND CDFILIAL      = ISNULL(@C_RAT_CDFILIAL, @C_MOVI_CDFILIAL)
                                     AND CDCENTCUST    = @C_RAT_CDCENTCUST;

                               END;

                               SET @V_VRRATEIO = @V_VRRATEIO + ROUND((@C_MOVI_VRMOVICRED * @C_RAT_VRPERATTPCRE)/100,2);

                               SET @V_RATSEQ = @V_RATSEQ + 1;

                               -- FILIAL E CENTRO DE CUSTO USADOS PARA ARREDONDAR ULTIMO RATEIO, CASO D DIFERENA
                               SET @V_CDFILIAL   = ISNULL(@C_RAT_CDFILIAL, @C_MOVI_CDFILIAL);
                               SET @V_CDCENTCUST = @C_RAT_CDCENTCUST;

                               FETCH NEXT FROM C_RAT INTO @C_RAT_CDCENTCUST, @C_RAT_CDFILIAL, @C_RAT_VRPERATTPCRE;
                            END;
                            CLOSE C_RAT;
                            DEALLOCATE C_RAT;

                            SET @V_RATSEQ = 1;
                            IF @V_VRRATEIO <> @C_MOVI_VRMOVICRED BEGIN
                               SET @V_VRRATEIO = @C_MOVI_VRMOVICRED - @V_VRRATEIO;
                                UPDATE RATECTBTEMP
                                   SET VRRATECTBTEMP = VRRATECTBTEMP + @V_VRRATEIO
                                 WHERE CDEMPRESA     = @V_CDEMPRESA
                                   AND NRLANCCTBTEMP = @V_NRLANCTEMP
                                   AND NRSEQCTBTEMP  = '00002'
                                   AND CDFILIAL      = @V_CDFILIAL
                                   AND CDCENTCUST    = @V_CDCENTCUST;
                            END;
                      END
                      ELSE BEGIN
                         SELECT @V_CDCENTCUST = CDCENTCUST
                           FROM FILIAL
                          WHERE CDFILIAL = @C_MOVI_CDFILIAL;

                         IF @V_CDCENTCUST IS NULL BEGIN
                            SELECT @V_CDCENTCUST = CDCENTCUST
                              FROM EMPRESA
                             WHERE CDEMPRESA = @V_CDEMPRESA;
                         END;

                         SET @V_COUNT = 0;
                         SELECT @V_COUNT = COUNT(*),
                                @V_SEQUENCIAL = R.NRSEQCTBTEMP
                           FROM RATECTBTEMP R, LANCCTBTEMP L
                          WHERE R.CDEMPRESA     = @V_CDEMPRESA
                            AND R.NRLANCCTBTEMP = @V_NRLANCTEMP
                            AND CDFILIAL        = ISNULL(@V_CDFILIAL, @C_MOVI_CDFILIAL)
                            AND CDCENTCUST      = @V_CDCENTCUST
                            AND L.NRLANCCTBTEMP = R.NRLANCCTBTEMP
                            AND L.NRSEQCTBTEMP  = R.NRSEQCTBTEMP
                            AND L.CDEMPRESA     = R.CDEMPRESA
                            AND L.CDCONTCTBL    = @C_MOVI_CONTA_CRE
                          GROUP BY R.NRSEQCTBTEMP;

                          IF @V_COUNT = 0 BEGIN
                          INSERT INTO RATECTBTEMP
                            (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                          VALUES
                            (@V_CDEMPRESA, @V_NRLANCTEMP, '00002', ISNULL(@V_CDFILIAL, @C_MOVI_CDFILIAL), @V_CDCENTCUST, @C_MOVI_VRMOVICRED, @C_MOVI_DTMOVICRED, '00001');

                          END
                          ELSE BEGIN
                             UPDATE RATECTBTEMP
                                SET VRRATECTBTEMP = VRRATECTBTEMP + @C_MOVI_VRMOVICRED
                              WHERE CDEMPRESA     = @V_CDEMPRESA
                                AND NRLANCCTBTEMP = @V_NRLANCTEMP
                                AND CDFILIAL      = ISNULL(@V_CDFILIAL, @C_MOVI_CDFILIAL)
                                AND CDCENTCUST    = @V_CDCENTCUST
                                AND NRSEQCTBTEMP  = @V_SEQUENCIAL;

                          END;
                       END;
                   END;
                END;

            FETCH NEXT FROM C_MOVI INTO @C_MOVI_CDREDUCONT, @C_MOVI_NRMOVICRED, @C_MOVI_CDHISTPADR, @C_MOVI_CONTA_DEB,
               @C_MOVI_DTMOVICRED, @C_MOVI_VRMOVICRED, @C_MOVI_CDCLIENTE, @C_MOVI_CDFORNECED, @C_MOVI_CDFILIAL, @C_MOVI_CONTA_CRE,
               @C_MOVI_CDTPCREDBANC, @C_MOVI_NRDOCMBANC;

            END;
            CLOSE C_MOVI;
            DEALLOCATE C_MOVI;

            IF @P_NRLANCCTBTEMP IS NULL BEGIN
               --SALVA NA TABELA DE MOVIMENTAO DE CRDITO BANCRIO, O NMERO DE LANAMENTO CONTBIL
               UPDATE MOVCREDBANC
                  SET NRLCTBMCRED = @V_NRLANCTEMP
                WHERE CDREDUCONT  = @P_CDREDUCONT
                  AND NRMOVICRED  = @P_NRMOVI;
            END;

            /* TRMINO DAS PARTIDAS DO LANCAMENTO CONTABIL*/

            /*VERIFICACAO DE ERROS NAS PARTIDAS E NO LANCAMENTO CONTABIL*/
            EXEC VERIFICA_ERRO_CTB N@V_NRLANCTEMP, @V_CDEMPRESA;

            /* GRAVA O LANAMENTO TEMPORRIO SE NO CONTER ERRO NA LANCCONT E LANCCUSTO, APS GRAVAR IR APAGAR O LANCAMENTO TEMPORRIO */
            EXEC GRAVA_LANC_CTB @V_NRLANCTEMP, @V_CDEMPRESA;


            IF @P_NRLANCCTBTEMP IS NULL BEGIN
               UPDATE MOVDEBBANC
                  SET NRLCTBMDEB = @V_NRLANCTEMP
                WHERE CDREDUCONT = @P_CDREDUCONT
                  AND NRMOVIDEBI = @P_NRMOVI;
            END;
            SET @P_NRLANCCTB = @V_NRLANCTEMP;
      END;
   END
   ELSE BEGIN
      SELECT  @V_DTLANCTBTEMP = DTMOVIDEBI
       FROM MOVDEBBANC
      WHERE CDREDUCONT = @P_CDREDUCONT
        AND NRMOVIDEBI = @P_NRMOVI;

      SELECT @V_COUNT = COUNT(*)
        FROM PARAMCTBL
       WHERE @V_DTLANCTBTEMP >= DTINTCTBBCO;

      IF @V_COUNT > 0 BEGIN
         IF @V_NRLANCTEMP IS NULL BEGIN
            SET @V_STDATA = 'LANCCONTABIL'+@V_CDEMPRESA+CONVERT(VARCHAR,YEAR(@V_DTLANCTBTEMP))+ CONVERT(VARCHAR,MONTH(@V_DTLANCTBTEMP));
            EXEC NOVO_CODIGO @V_STDATA,@V_NRLANCTEMP OUTPUT,1
            SET @V_NRLANCTEMP = CONVERT(VARCHAR,YEAR(@V_DTLANCTBTEMP))+ CONVERT(VARCHAR,MONTH(@V_DTLANCTBTEMP))+ SUBSTRING(@V_NRLANCTEMP, 15, 6);
         END;

         DELETE FROM LANCCTBTEMP
          WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
            AND CDEMPRESA     = @V_CDEMPRESA;

         DELETE FROM RATECTBTEMP
          WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
            AND CDEMPRESA     = @V_CDEMPRESA;

         DECLARE C_MOVI CURSOR FOR
            (SELECT M.CDREDUCONT, M.NRMOVIDEBI, T.CDHISTPADR, C.CDCONTCTBL CONTA_CRE, DTMOVIDEBI,
                   M.VRMOVIDEBI, M.CDCLIENTE, M.CDFORNECED, M.CDFILIAL, T.CDCONTCTBL CONTA_DEB,
                   M.CDTPDEBIBANC, B.NRDOCMBANC
              FROM MOVDEBBANC M, TPDEBIBANC T, CONTCORR C, MOVBANCARIO B
             WHERE M.CDTPDEBIBANC = T.CDTPDEBIBANC
               AND M.CDREDUCONT   = C.CDREDUCONT
               AND M.NRMOVBANC    = B.NRMOVBANC
               AND M.CDREDUCONT   = B.CDREDUCONT
               AND M.CDREDUCONT = @P_CDREDUCONT
               AND M.NRMOVIDEBI = @P_NRMOVI);

             OPEN C_MOVI;
             FETCH NEXT FROM C_MOVI INTO @C_MOVI_CDREDUCONT, @C_MOVI_NRMOVIDEBI, @C_MOVI_CDHISTPADR, @C_MOVI_CONTA_CRE,
             @C_MOVI_DTMOVIDEBI, @C_MOVI_VRMOVIDEBI, @C_MOVI_CDCLIENTE, @C_MOVI_CDFORNECED, @C_MOVI_CDFILIAL, @C_MOVI_CONTA_DEB,
             @C_MOVI_CDTPDEBIBANC, @C_MOVI_NRDOCMBANC;

             WHILE (@@FETCH_STATUS = 0) BEGIN

                -- Formata a Descrio do Histrico
                EXEC CTB_HIST_BCO @C_MOVI_CDREDUCONT, @C_MOVI_NRMOVIDEBI, @C_MOVI_CDHISTPADR, '','D', @P_STDSHISTPADR = @V_DSHISTLANC OUTPUT;


                /*************************************************************************************
                                PARTIDA DE CRDITO - CONTA CONTBIL DA CONTA CORRENTE
                ************************************************************************************/
                -- Verifica se a conta contbil  do tipo comercial (banco, fornecedor ou cliente) --
                SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME, 'N'),  @V_IDCONTCCUS = IDCONTCCUS
                  FROM CONTCTBL
                 WHERE CDCONTCTBL = @C_MOVI_CONTA_CRE;

                IF @V_IDTIPOCOME = 'B' BEGIN
                   SET @V_CDCONTCOME = @C_MOVI_CDREDUCONT;
                END

                ELSE IF @V_IDTIPOCOME = 'C' BEGIN
                   SET @V_CDCONTCOME = @C_MOVI_CDCLIENTE;
                END

                ELSE IF @V_IDTIPOCOME = 'F' BEGIN
                   SET @V_CDCONTCOME = @C_MOVI_CDFORNECED;
                END

                ELSE BEGIN
                   SET @V_CDCONTCOME = NULL;
                END;

                SET @V_COUNT = 0;
                SELECT @V_COUNT = COUNT(*)
                  FROM LANCCTBTEMP
                 WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                   AND CDEMPRESA     = @V_CDEMPRESA
                   AND CDCONTCTBL    = @C_MOVI_CONTA_CRE;

                IF @V_COUNT = 0 BEGIN
                   INSERT INTO LANCCTBTEMP
                     (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR, CDDOCUTEMP,
                      DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                   VALUES
                     (@V_CDEMPRESA, @V_NRLANCTEMP, '00001',@C_MOVI_CONTA_CRE, @C_MOVI_CDHISTPADR, @C_MOVI_NRDOCMBANC,
                      @V_DSHISTLANC, @C_MOVI_DTMOVIDEBI, @C_MOVI_VRMOVIDEBI, @V_IDTIPOCOME, @V_CDCONTCOME, 'BCO');
                END
                ELSE BEGIN
                   UPDATE LANCCTBTEMP
                      SET VRLANCCTBTEMP = VRLANCCTBTEMP + @C_MOVI_VRMOVIDEBI
                    WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                      AND CDEMPRESA     = @V_CDEMPRESA
                      AND CDCONTCTBL    = @C_MOVI_CONTA_CRE;
                END;

                -- Realiza o rateio caso a conta contbil no seja "S Oficial" --
                IF @V_CONTRAT = 'S' BEGIN
                   IF @V_IDCONTCCUS <> 'O' BEGIN

                      SELECT @V_CDCENTCUST = CDCENTCUST
                        FROM FILIAL
                       WHERE CDFILIAL = @C_MOVI_CDFILIAL;

                      IF @V_CDCENTCUST IS NULL BEGIN
                         SELECT @V_CDCENTCUST = CDCENTCUST
                           FROM EMPRESA
                          WHERE CDEMPRESA = @V_CDEMPRESA;
                      END;

                      SET @V_COUNT = 0;
                      SELECT @V_COUNT = COUNT(*)
                        FROM RATECTBTEMP
                       WHERE CDEMPRESA     = @V_CDEMPRESA
                         AND NRLANCCTBTEMP = @V_NRLANCTEMP
                         AND CDFILIAL      = @C_MOVI_CDFILIAL
                         AND CDCENTCUST    = @V_CDCENTCUST
                         AND NRSEQCTBTEMP  = '00001';

                      IF @V_COUNT = 0 BEGIN

                         INSERT INTO RATECTBTEMP
                            (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                         VALUES
                           (@V_CDEMPRESA, @V_NRLANCTEMP, '00001',  @C_MOVI_CDFILIAL, @V_CDCENTCUST, @C_MOVI_VRMOVIDEBI, @C_MOVI_DTMOVIDEBI, '00001');

                      END
                      ELSE BEGIN
                         UPDATE RATECTBTEMP
                            SET VRRATECTBTEMP = VRRATECTBTEMP + @C_MOVI_VRMOVIDEBI
                          WHERE CDEMPRESA     = @V_CDEMPRESA
                            AND NRLANCCTBTEMP = @V_NRLANCTEMP
                            AND CDFILIAL      = @C_MOVI_CDFILIAL
                            AND CDCENTCUST    = @V_CDCENTCUST
                            AND NRSEQCTBTEMP  = '00001';
                      END;
                   END;
                END;



                /*************************************************************************************
                                  PARTIDA DE DBITO - CONTA CONTBIL TIPO DE DBITO
                ************************************************************************************/
                SET @V_IDTIPOCOME = NULL;
                SET @V_IDCONTCCUS = NULL;
                SET @V_VRRATEIO   = 0;
                SET @V_COUNT      = 0;

                  -- Verifica se a conta contbil  do tipo comercial (banco, fornecedor ou cliente) --
                SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME, 'N'),  @V_IDCONTCCUS = IDCONTCCUS
                  FROM CONTCTBL
                 WHERE CDCONTCTBL = @C_MOVI_CONTA_DEB;

                IF @V_IDTIPOCOME = 'B' BEGIN
                   SET @V_CDCONTCOME = @C_MOVI_CDREDUCONT;
                END

                ELSE IF @V_IDTIPOCOME = 'C' BEGIN
                   SET @V_CDCONTCOME = @C_MOVI_CDCLIENTE;
                END

                ELSE IF @V_IDTIPOCOME = 'F' BEGIN
                   SET @V_CDCONTCOME = @C_MOVI_CDFORNECED;
                END

                ELSE BEGIN
                   SET @V_CDCONTCOME = NULL;
                END;

                SET @V_COUNT = 0;
                SELECT @V_COUNT = COUNT(*)
                  FROM LANCCTBTEMP
                 WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                   AND CDEMPRESA  = @V_CDEMPRESA
                   AND CDCONTCTBL = @C_MOVI_CONTA_DEB;

                IF @V_COUNT = 0 BEGIN
                   INSERT INTO LANCCTBTEMP
                     (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR, CDDOCUTEMP,
                      DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                  VALUES
                     (@V_CDEMPRESA, @V_NRLANCTEMP, '00002', @C_MOVI_CONTA_DEB, @C_MOVI_CDHISTPADR, @C_MOVI_NRDOCMBANC,
                      @V_DSHISTLANC, @C_MOVI_DTMOVIDEBI, @C_MOVI_VRMOVIDEBI * -1, @V_IDTIPOCOME, @V_CDCONTCOME, 'BCO');
                END
                ELSE BEGIN
                   UPDATE LANCCTBTEMP
                      SET VRLANCCTBTEMP = VRLANCCTBTEMP + (@C_MOVI_VRMOVIDEBI * -1)
                    WHERE NRLANCCTBTEMP  = @V_NRLANCTEMP
                      AND CDEMPRESA     = @V_CDEMPRESA
                      AND CDCONTCTBL    = @C_MOVI_CONTA_DEB;
                END;

                IF @V_CONTRAT = 'S' BEGIN
                   IF @V_IDCONTCCUS <> 'O' BEGIN
                      SELECT @V_COUNT = COUNT(*)
                        FROM RATTPDEBI
                       WHERE CDTPDEBIBANC = @C_MOVI_CDTPDEBIBANC;
                      IF @V_COUNT > 0 BEGIN
                         SET @V_RATSEQ = 1;
                         DECLARE C_RAT CURSOR FOR
                            (SELECT CDCENTCUST, CDFILIAL,  VRPERATTPDEB
                               FROM RATTPDEBI
                              WHERE CDTPDEBIBANC = @C_MOVI_CDTPDEBIBANC);
                            OPEN C_RAT;
                            FETCH NEXT FROM C_RAT INTO @C_RAT_CDCENTCUST, @C_RAT_CDFILIAL, @C_RAT_VRPERATTPDEB;
                            WHILE (@@FETCH_STATUS = 0) BEGIN
                               SET @V_COUNT = 0;
                               SELECT @V_COUNT = COUNT(*)
                                 FROM RATECTBTEMP  R
                                WHERE CDFILIAL     = ISNULL(@C_RAT_CDFILIAL, @C_MOVI_CDFILIAL)
                                  AND CDCENTCUST   = @C_RAT_CDCENTCUST
                                  AND R.CDEMPRESA  = @V_CDEMPRESA
                                  AND R.NRLANCCTBTEMP = @V_NRLANCTEMP
                                  AND R.NRSEQCTBTEMP  = '00002';

                               IF @V_COUNT = 0 BEGIN

                                  INSERT INTO RATECTBTEMP
                                     (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                                  VALUES
                                     (@V_CDEMPRESA, @V_NRLANCTEMP, '00002', ISNULL(@C_RAT_CDFILIAL, @C_MOVI_CDFILIAL), @C_RAT_CDCENTCUST,
                                  ROUND(((@C_MOVI_VRMOVIDEBI * @C_RAT_VRPERATTPDEB)/100) * -1, 2), @C_MOVI_DTMOVIDEBI, RIGHT(REPLICATE('0',5)+ CONVERT(VARCHAR(5), @V_RATSEQ),5));
                               END
                               ELSE BEGIN
                                  UPDATE RATECTBTEMP
                                     SET VRRATECTBTEMP = VRRATECTBTEMP +  ROUND(((@C_MOVI_VRMOVIDEBI * @C_RAT_VRPERATTPDEB)/100) * -1, 2)
                                   WHERE CDFILIAL     = ISNULL(@C_RAT_CDFILIAL, @C_MOVI_CDFILIAL)
                                     AND CDCENTCUST   = @C_RAT_CDCENTCUST
                                     AND CDEMPRESA  = @V_CDEMPRESA
                                     AND NRLANCCTBTEMP = @V_NRLANCTEMP
                                     AND NRSEQCTBTEMP = '00002';

                               END;

                               SET @V_VRRATEIO = @V_VRRATEIO + ROUND((@C_MOVI_VRMOVIDEBI * @C_RAT_VRPERATTPDEB)/100, 2);
                               SET @V_RATSEQ = @V_RATSEQ + 1;

                               /* FILIAL E CENTRO DE CUSTO USADOS PARA ARREDONDAR ULTIMO RATEIO, CASO D DIFERENA */
                               SET @V_CDFILIAL   = ISNULL(@C_RAT_CDFILIAL, @C_MOVI_CDFILIAL);
                               SET @V_CDCENTCUST = @C_RAT_CDCENTCUST;

                               FETCH NEXT FROM C_RAT INTO @C_RAT_CDCENTCUST, @C_RAT_CDFILIAL, @C_RAT_VRPERATTPDEB;
                            END;
                            SET @V_RATSEQ = 1;
                            CLOSE C_RAT;
                            DEALLOCATE C_RAT;

                            IF @V_VRRATEIO <> @C_MOVI_VRMOVIDEBI BEGIN
                               SET @V_VRRATEIO = @C_MOVI_VRMOVIDEBI - @V_VRRATEIO;
                               UPDATE RATECTBTEMP
                                  SET VRRATECTBTEMP = VRRATECTBTEMP + @V_VRRATEIO
                                WHERE CDEMPRESA     = @V_CDEMPRESA
                                  AND NRLANCCTBTEMP = @V_NRLANCTEMP
                                  AND NRSEQCTBTEMP  = '00002'
                                  AND CDFILIAL      = @V_CDFILIAL
                                  AND CDCENTCUST    = @V_CDCENTCUST;
                            END;
                      END
                      ELSE BEGIN
                         SELECT @V_CDCENTCUST = CDCENTCUST
                           FROM FILIAL
                          WHERE CDFILIAL = @C_MOVI_CDFILIAL;

                         IF @V_CDCENTCUST IS NULL BEGIN
                            SELECT @V_CDCENTCUST = CDCENTCUST
                              FROM EMPRESA
                             WHERE CDEMPRESA = @V_CDEMPRESA;
                         END;

                         SET @V_RATSEQ = 1;
                         SELECT @V_COUNT = COUNT(*),@V_SEQUENCIAL = L.NRSEQCTBTEMP
                           FROM RATECTBTEMP  R, LANCCTBTEMP L
                          WHERE CDFILIAL     = ISNULL(@V_CDFILIAL, @C_MOVI_CDFILIAL)
                            AND CDCENTCUST   = @V_CDCENTCUST
                            AND R.CDEMPRESA  = @V_CDEMPRESA
                            AND R.NRLANCCTBTEMP = @V_NRLANCTEMP
                            AND R.CDEMPRESA     = L.CDEMPRESA
                            AND R.NRLANCCTBTEMP = L.CDEMPRESA
                            AND L.CDCONTCTBL    = @C_MOVI_CONTA_CRE
                          GROUP BY L.NRSEQCTBTEMP;
                         IF @V_COUNT = 0  BEGIN

                            INSERT INTO RATECTBTEMP
                               (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL,
                                CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                             VALUES
                               (@V_CDEMPRESA, @V_NRLANCTEMP, '00002', ISNULL(@V_CDFILIAL, @C_MOVI_CDFILIAL),
                                @V_CDCENTCUST, @C_MOVI_VRMOVIDEBI * -1, @C_MOVI_DTMOVIDEBI, '00001');
                         END
                         ELSE BEGIN
                            UPDATE RATECTBTEMP
                               SET VRRATECTBTEMP = VRRATECTBTEMP +  ROUND(@C_MOVI_VRMOVIDEBI * -1, 2)
                             WHERE CDFILIAL      = ISNULL(@V_CDFILIAL, @C_MOVI_CDFILIAL)
                               AND CDCENTCUST    = @V_CDCENTCUST
                               AND CDEMPRESA     = @V_CDEMPRESA
                               AND NRLANCCTBTEMP = @V_NRLANCTEMP
                               AND NRSEQCTBTEMP  = @V_SEQUENCIAL;

                         END;
                      END;
                   END;
                END;
                FETCH NEXT FROM C_MOVI INTO @C_MOVI_CDREDUCONT, @C_MOVI_NRMOVIDEBI, @C_MOVI_CDHISTPADR, @C_MOVI_CONTA_CRE,
                   @C_MOVI_DTMOVIDEBI, @C_MOVI_VRMOVIDEBI, @C_MOVI_CDCLIENTE, @C_MOVI_CDFORNECED, @C_MOVI_CDFILIAL, @C_MOVI_CONTA_DEB,
                   @C_MOVI_CDTPDEBIBANC, @C_MOVI_NRDOCMBANC;


             END;
             CLOSE C_MOVI;
             DEALLOCATE C_MOVI;

            /* TRMINO DAS PARTIDAS DO LANCAMENTO CONTABIL*/

            /*VERIFICACAO DE ERROS NAS PARTIDAS E NO LANCAMENTO CONTABIL*/
            EXEC VERIFICA_ERRO_CTB N@V_NRLANCTEMP, @V_CDEMPRESA;

            /* GRAVA O LANAMENTO TEMPORRIO SE NO CONTER ERRO NA LANCCONT E LANCCUSTO, APS GRAVAR IR APAGAR O LANCAMENTO TEMPORRIO */
            EXEC GRAVA_LANC_CTB @V_NRLANCTEMP, @V_CDEMPRESA;

            SET @P_NRLANCCTB = @V_NRLANCTEMP;

         IF @P_NRLANCCTBTEMP IS NULL BEGIN
            UPDATE MOVDEBBANC
               SET NRLCTBMDEB = @V_NRLANCTEMP
             WHERE CDREDUCONT = @P_CDREDUCONT
               AND NRMOVIDEBI = @P_NRMOVI;
         END;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CTB_BCO_LANC','5.50.000';
GO

